/*

  seng.c: A Search ENGine.
  Copyright (C) 2000 Thomas Repantis <darkzero@otenet.gr>
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  
*/
 

#include <stdio.h>    /*fgets is included herein.*/
#include <string.h>   /*To use strsep.*/
#include <stdlib.h>   /*To use malloc.*/
#include <time.h>     /*To use clock.*/

#define FILENAME_LENGTH 50
#define LINE_LENGTH 1000
#define WORD_LENGTH 50
#define TABLE_SIZE 50021 /*A prime number should be best for our hash function.
			   Easily calculated by the accompanying nextprime.c
			   program, if we need to change this.
			   (e.g. Huge files may need larger hash table.)*/


typedef unsigned int Index;

typedef struct {
  char word[WORD_LENGTH];
  char filename[FILENAME_LENGTH];
} ElementType;

struct ListNode;
typedef struct ListNode *Position;
typedef Position List;
struct HashTbl;
typedef struct HashTbl *HashTable;

extern char word2find[WORD_LENGTH];
extern char secondword[WORD_LENGTH];
extern int numberofwords;

struct ListNode {
  ElementType Element;
  Position    Next;
};

struct HashTbl{
  int TableSize;
  List *ArrayOfLists;
};


HashTable InitializeTable( int TableSize );
void DestroyTable( HashTable H );
void PrintTable( HashTable H );
Position Find( ElementType Key, HashTable H );
void Insert( ElementType Key, HashTable H );
Index Hash(const char *Key, int TableSize);
void ReadFile(char *filename, HashTable H);        
void SearchFor(char *word2find, char *secondword, char *status, HashTable H);


